/* qs18d.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__15 = 15;

/* Subroutine */ int qs18d_c(doublereal *rint, doublereal *a, doublereal *b,
        D_fp f, doublereal *w, doublereal *fi, doublereal *e, integer *l, 
        doublereal *ra, doublereal *rb, integer *ierr)
{
    /* Initialized data */

    static doublereal x[16] = { .4986319309247408,.4928057557726342,
            .4823811277937532,.4674530379688698,.4481605778830261,
            .424683806866285,.3972418979839712,.3660910593701448,
            .3315221334651076,.2938578786203812,.2534499544661147,
            .2106756380653177,.1659343011410638,.1196436811260685,
            .0722359807913982,.0241538328438692 };
    static doublereal c__[16] = { .003509305004735,.0081371973654528,
            .012696032654631,.0171369314565107,.0214179490111133,
            .0254990296311881,.0293420467392678,.0329111113881809,
            .0361728970544243,.0390969478935352,.0416559621134734,
            .0438260465022019,.0455869393478819,.0469221995404023,
            .0478193600396374,.0482700442573639 };
    static doublereal pi = 3.141592653589793;

    /* Format strings */
    static char fmt_220[] = "";
    static char fmt_80[] = "";
    static char fmt_100[] = "";
    static char fmt_110[] = "";
    static char fmt_120[] = "";
    static char fmt_130[] = "";
    static char fmt_180[] = "";

    /* System generated locals */
    integer i__1, i__2;
    doublereal d__1, d__2, d__3, d__4;

    /* Builtin functions */
    double sin(doublereal);

    /* Local variables */
    static doublereal h__;
    static integer i__, j, k, m, n;
    static doublereal q, r__, a0, b0, e0;
    static integer i0, i1, k0, n0, n1;
    extern /* Subroutine */ int utqs13_c(integer *, integer *);
    static integer n2;
    static doublereal q0, r0, r1, r2, x0, x1, xa, qj, ri, rj, xb, ra1, ra2, 
            rb1, rb2, xa0, xb0;

    /* Assigned format variables */
    static char *m_fmt;

    /* Parameter adjustments */
    --rb;
    --ra;

    /* Function Body */
    q = *w;
    r__ = *fi;
    n = *l;
    *ierr = 0;
    if ((d__1 = *b - *a) < 0.) {
        goto L10;
    } else if (d__1 == 0) {
        goto L20;
    } else {
        goto L30;
    }
L10:
    a0 = *b;
    b0 = *a;
    j = -1;
    goto L40;
L20:
    *rint = 0.;
    k = 0;
    goto L240;
L30:
    a0 = *a;
    b0 = *b;
    j = 1;
L40:
    if (q >= 0.) {
        goto L50;
    }
    qj = -q;
    rj = -r__;
    j = -j;
    goto L60;
L50:
    qj = q;
    rj = r__;
L60:
    q0 = qj / pi;
    r0 = rj / pi;
    r1 = q0 * a0 + r0;
    n1 = (integer) r1;
    if (r1 >= 0.) {
        ++n1;
    }
    r2 = q0 * b0 + r0;
    n2 = (integer) r2;
    if (r2 < 0.) {
        --n2;
    }
    n0 = n2 - n1;
    k = n0 + 1;
    if (n0 >= 1) {
        goto L70;
    }
    h__ = b0 - a0;
    x1 = a0 + h__ * .5;
    *rint = 0.;
    m = 0;
    m_fmt = fmt_220;
    goto L200;
L70:
    h__ = pi / qj;
    xa0 = h__ * n1 - rj / qj;
    xb0 = xa0 + h__ * n0;
    if (n0 >= 2) {
        goto L90;
    }
    x1 = xa0 + h__ * .5;
    m = 1;
    m_fmt = fmt_80;
    goto L200;
L80:
    *rint = ri;
    goto L170;
L90:
    if (k > n) {
        k = n;
    }
    xa = xa0;
    x1 = xa + h__ * .5;
    m = 2;
    m_fmt = fmt_100;
    goto L200;
L100:
    ra[1] = ri;
    ra[2] = ri * .5;
    ra1 = ri;
    xb = xb0;
    x1 = xb - h__ * .5;
    m = 3;
    m_fmt = fmt_110;
    goto L200;
L110:
    rb[1] = ri;
    rb[2] = ri * .5;
    rb1 = ri;
    i__1 = k;
    for (i__ = 3; i__ <= i__1; ++i__) {
        k0 = i__;
        xa += h__;
        x1 = xa + h__ * .5;
        m = 4;
        m_fmt = fmt_120;
        goto L200;
L120:
        ra[1] += ri;
        ra[i__] = ra[1];
        xb -= h__;
        x1 = xb - h__ * .5;
        m = 5;
        m_fmt = fmt_130;
        goto L200;
L130:
        rb[1] += ri;
        rb[i__] = rb[1];
        i__2 = i__;
        for (i1 = 2; i1 <= i__2; ++i1) {
            i0 = i1;
            ra2 = ra[i1];
            ra[i1] = (ra[i1 - 1] + ra1) * .5;
            rb2 = rb[i1];
            rb[i1] = (rb[i1 - 1] + rb1) * .5;
            e0 = (d__1 = ra[i1] - ra1, abs(d__1)) + (d__2 = ra[i1 - 1] - ra1, 
                    abs(d__2)) + (d__3 = rb[i1] - rb1, abs(d__3)) + (d__4 = 
                    rb[i1 - 1] - rb1, abs(d__4));
            if (e0 <= *e) {
                goto L160;
            }
            ra1 = ra2;
            rb1 = rb2;
/* L140: */
        }
/* L150: */
    }
    *ierr = 65;
    utqs13_c(ierr, &c__15);
L160:
    *rint = ra[i0] + rb[i0];
    k = k0;
L170:
    h__ = xa0 - a0;
    if (h__ <= 0.) {
        goto L190;
    }
    x1 = a0 + h__ * .5;
    m = 6;
    m_fmt = fmt_180;
    goto L200;
L180:
    *rint += ri;
L190:
    h__ = b0 - xb0;
    if (h__ <= 0.) {
        goto L230;
    }
    x1 = b0 - h__ * .5;
    m = 0;
    m_fmt = fmt_220;
L200:
    ri = 0.;
    for (i1 = 1; i1 <= 16; ++i1) {
        x0 = h__ * x[i1 - 1];
        d__1 = x1 + x0;
        d__2 = x1 - x0;
        ri += c__[i1 - 1] * ((*f)(&d__1) * sin(qj * (x1 + x0) + rj) +
                (*f)(&d__2) * sin(qj * (x1 - x0) + rj));
/* L210: */
    }
    ri = h__ * ri;
    switch (m) {
        case 0: goto L220;
        case 1: goto L80;
        case 2: goto L100;
        case 3: goto L110;
        case 4: goto L120;
        case 5: goto L130;
        case 6: goto L180;
    }
L220:
    *rint += ri;
L230:
    *rint *= j;
L240:
    return 0;
} /* qs18d_c */
